#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl -w
use strict;
use PureMessage::Manager::Lang;
use PureMessage::Enduser::Request qw(%in);
use PureMessage::Enduser::Response;
use PureMessage::Enduser::UI::User;
use PureMessage::MIME::Header qw(header_utf8);
use ActiveState::I18N::UTF8 qw(utf8_encode utf8_header);
use PureMessage::UTF8::Config qw(%utf8_config);
use HTML::Entities;
my $REQUEST = new PureMessage::Enduser::Request;
my $r = $REQUEST->get_response('', stderr_to_stdout => 0, 'titlebar-only' => 1, 'no_image' => 1);

# set language name space
PureMessage::Manager::Lang::set_namespace("EUUI/message");

# user object does data retrieval
my $user;
if (! $r->authorize_user) {
    $r->send();
    exit;
} else {
    $user = $r->user();
}

# set the language
my $lang = $user->language();
$r->errors($user, $0, 'language', 'get_language_error');

my $mess_id = $in{'message_id'};
if (defined $mess_id) {
    my $message_body = $user->get_msg_body($mess_id);
    if (! $message_body) {
        if ($user->error =~ /^RPC call failed: DBD::Pg::st fetch failed: no statement executing/
            or $user->error eq 'rpc_no_body_content') {
            PureMessage::Manager::Lang::set_namespace("EUUI/response");
            $r->raise_error(lang_text_utf8($lang, 'message_expired'));
            print STDERR "Problem retrieving message body data: " . $user->error . "\n";
        } else {
            $r->errors($user, $0, 'get_msg_body');
        }
	$r->send;
	exit;
    }
    my $mess_tmpl = $r->new_tmpl('content_show_message.html');
    my $body = $message_body->{body};
    # XXX &nbsp; should be decoded into 0xa0, however, it will confuse
    # utf8-encoder's guess
    $body =~ s/&nbsp;/ /gi;
    decode_entities($body);
    utf8_encode($body, undef, \%utf8_config);
    my $to = $message_body->{'h_to'};
    utf8_header($to, \%utf8_config);
    my $from = $message_body->{'h_from'};
    utf8_header($from, \%utf8_config);
    $mess_tmpl->param('title_to' => lang_text_utf8($lang, 'title_to'),
		      'title_from' => lang_text_utf8($lang, 'title_from'),
		      'title_subject' => lang_text_utf8($lang, 'title_subject'),
		      'to' => $to,
		      'from' => $from,
		      'subject' => $message_body->{'c_subject_utf8'},
		      'message' => $body,
		      );
    $r->add_part($mess_tmpl);
    $r->send;
}
