#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use HTML::Template;
use ActiveState::Config qw( :path);
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Widget;
use PureMessage::Manager::Config qw(%config);
use PureMessage::Enduser::UI::Config qw( %enduser_ui_config );
use PureMessage::Manager::Lang;
use PureMessage::Manager::Response::Services::HTTPD;
use PureMessage::List;
use strict;

my %vars;
our %config;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::HTTPD',
                                'stderr_to_stdout' =>1 );


my %PATHS = ( 'HOST'    =>  ['RPC.host','#str','Host'],
              'PORT'    => ['RPC.port','#str','Port'],
              'TIMEOUT'    => ['RPC.timeout','#duration','RPC Timeout'],
           );



$r->addRestartDlg(type=>'httpd');
$r->{debug} = 0;
$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_rpc_end_user" );

$r->title(text('enduserui_options_title'));

my $action = $in{'action'};

$action = 'save' if $in{'save'};
$action = 'edit' if $in{'edit'};

# get template vars we always want
$vars{'ACTION'} = $action;

# revisit is always set when the form is submitted so this is the first view
# so if load isn't sent from the link to this page we should still have
# valid values
#
$in{'load'} = 1 if !$in{revisit};


if ($action =~ /save/) {
    $vars{'TITLE'} = &text('enduserui_options_title');
    $r->title(&text('enduserui_options_title'));
    if ( !hasValidateErrors() ) {
         commitUpdatedDataToDisk();
           # allow PM::Service::Config to not exist, like
           # for instance, if they have an older PM-Utils
           # without it.
           eval {
                 require PureMessage::Service::Config;
                 PureMessage::Service::Config::stale('httpd');
           };

    } 
} 

putEditPage();


### start of subs


sub putEditPage() {

    $vars{HEADER} = $r->ThemeSectionHeader( title=> text('enduserui_options_header'))->output(); 
    
    my @FEATURES;
    
    if ($in{load}) {
       foreach my $fname (keys %PATHS) {
          my $node = path_node($PureMessage::Enduser::UI::Config::object->root,$PATHS{$fname}->[0]);
          if ($fname eq 'HOST' or $fname eq 'PORT') {
            next if $fname eq 'PORT';
            $vars{$fname} = $node->value_formatted();
            $node = path_node($PureMessage::Enduser::UI::Config::object->root,$PATHS{'PORT'}->[0]);
            $vars{'PORT'} = $node->value_formatted();
            $vars{$fname} = $vars{$fname} . ":" . $vars{'PORT'};
          } else {
            $vars{$fname} = $node ? $node->value_formatted() : '';
          }
       }
    } else {
      foreach my $fname (keys %PATHS) {
        $vars{$fname} = $in{$fname};
      }
    }
  
    my $tb = $r->ToolBar(
                        buttons => [[ { type=>'image',text=>'Save',name=>'save',icon=>'save'},
                                      { type=>'image',text=>'Cancel',href=>'index.cgi',icon=>'cancel'},
                                   ]],
                        table=> [[1,3],['50%','50%']],
                      );
    $vars{FOOTER} = $r->ThemeSectionFooter(toolbar=>$tb)->output();

    $r->add_template( 'file'=>'tmpl/uioptions.html', 'data'=>\%vars );
    $r->send();

}

sub commitUpdatedDataToDisk {
   
    my %values;
    
    eval {
      my $conf = PureMessage::Enduser::UI::Config::edit();
      foreach my $k (keys %PATHS) {
            path_value($conf->root,$PATHS{$k}->[0],$in{$k});
      }
      $conf->save();
      PureMessage::Enduser::UI::Config::refresh();
    };

    if ($@) {
        # config died, deal with it
        $r->raise_error('error_index_saving_conf',$@);
        $r->error_dlg();
        $r->send();
        exit;
    }
    $r->addInfoBox( msg => text('message_update_ok'));
 
    $r->log('Update End User UI Features','','enduser', \%in);
}


sub hasValidateErrors {
    $in{HOST} = '' unless $in{HOST}; # validator won't check keys that don't exists in input
    $in{TIMEOUT} = '' unless $in{TIMEOUT}; # validator won't check keys that don't exists in input
                                             # so force this to exist
    foreach my $k (keys %PATHS) {
      if ($k eq 'HOST') {
         my @v = split(":",$in{$k});
         $in{HOST} = $v[0];
         $in{PORT} = $v[1] if $v[1];
      };
        
      $REQUEST->typedecl($k, $PATHS{$k}->[1],$PATHS{$k}->[2]);
    } 
    my @v_errors = $REQUEST->validate(\%in);
    if (@v_errors) {
        $r->raise_error(join("<br>", @v_errors));
    } 
    return $r->error() ? 1 : 0;
}



